#!/usr/bin/env python
# -*- coding: UTF-8 -*-
#
#   createBCsMultiRegionDialog.py
#
#       multiReginモデルの境界面の境界条件設定
#       OF-2.2以降
#
#   14/10/05    新規作成
#      10/06    replaceRegionFieldBoundaryConditions:includeファイルの挿入方法修正
#      10/15    dict読み込みを修正
#      10/16    変数名のエラーチェックを追加
#
#

# generated by wxGlade 0.6.7+ on Sun Sep 28 13:17:11 2014
#

import wx
import sys
import os
import glob
import pyTreeFoam
import getFoamContents
import setFoamContents

# begin wxGlade: dependencies
import gettext
# end wxGlade

# begin wxGlade: extracode
# end wxGlade

caseDir = ""
variables = ""
beforeFluidField = ""
beforeSolidField = ""
fluidRegions = []
fluidFields = []                #[[<field>, [<variable>, <yesNo>]], ...]
fluidBoundaryCont = []          #[<field>, <boundary>], .. , [..]]
solidRegions = []
solidFields = []
solidBoundaryCont = []
errFields = []                  #存在しないfield

includeDir = ""
includeDirOrg = ""
uniform = ""
noChange = ""


class MyFrame(wx.Frame):
    def __init__(self, *args, **kwds):
        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.label_1 = wx.StaticText(self, wx.ID_ANY, _(u"領域間の境界条件の編集・設定 (Region Boundary Editor)"))
        self.label_2 = wx.StaticText(self, wx.ID_ANY, _(u"変数名、値の定義"))
        self.text_ctrl_1 = wx.TextCtrl(self, wx.ID_ANY, "", style=wx.TE_MULTILINE)
        self.label_3 = wx.StaticText(self, wx.ID_ANY, _(u"fluid, solid領域で使用する変数を定義。\n\n変数や境界条件は、includeファイルで設定される。\n境界面のpatch名は「\".*._to_.*\"」で定義され、\n内容はincludeファイルを参照する。"))
        self.sizer_2_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"変数設定（fluid solid 共用）"))
        self.label_12 = wx.StaticText(self, wx.ID_ANY, _(u"field名を選択後、そのfieldの内容を設定する。\ninternalFieldと境界面のboundaryFieldを設定する。"))
        self.label_4 = wx.StaticText(self, wx.ID_ANY, _(u"field名"))
        self.list_box_1 = wx.ListBox(self, wx.ID_ANY, choices=[])
        self.label_6 = wx.StaticText(self, wx.ID_ANY, _("internalField:"))
        self.combo_box_1 = wx.ComboBox(self, wx.ID_ANY, choices=[], style=wx.CB_DROPDOWN)
        self.label_7 = wx.StaticText(self, wx.ID_ANY, _(u"境界面の境界条件"))
        self.text_ctrl_2 = wx.TextCtrl(self, wx.ID_ANY, "", style=wx.TE_MULTILINE)
        self.sizer_8_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"fluid領域"))
        self.label_8 = wx.StaticText(self, wx.ID_ANY, _(u"field名"))
        self.list_box_2 = wx.ListBox(self, wx.ID_ANY, choices=[])
        self.label_10 = wx.StaticText(self, wx.ID_ANY, _("internalField:"))
        self.combo_box_2 = wx.ComboBox(self, wx.ID_ANY, choices=[], style=wx.CB_DROPDOWN)
        self.label_11 = wx.StaticText(self, wx.ID_ANY, _(u"境界面の境界条件"))
        self.text_ctrl_3 = wx.TextCtrl(self, wx.ID_ANY, "", style=wx.TE_MULTILINE)
        self.sizer_15_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"solid領域"))
        self.sizer_24_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"fieldの設定"))
        self.button_1 = wx.Button(self, wx.ID_ANY, _(u"キャンセル"))
        self.button_2 = wx.Button(self, wx.ID_ANY, _(u"設定"))

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_LISTBOX, self.onSelectFluidField, self.list_box_1)
        self.Bind(wx.EVT_LISTBOX, self.onSelectSolidField, self.list_box_2)
        self.Bind(wx.EVT_BUTTON, self.onCansel, self.button_1)
        self.Bind(wx.EVT_BUTTON, self.onSetAllFields, self.button_2)
        # end wxGlade

        self.showFluidInternalBoundaryField(fluidFields[0][0])
        self.showSolidInternalBoundaryField(solidFields[0][0])


    def __set_properties(self):
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle(_(u"境界条件の設定"))
        self.text_ctrl_1.SetMinSize((258, 120))
        self.list_box_1.SetMinSize((110, 120))
        # end wxGlade

        self.setVariablesTextBox()
        self.setFieldsListBox()
        self.setComboBox()
        self.setBoundatyTextBox()


    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_22 = wx.BoxSizer(wx.VERTICAL)
        sizer_23 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_24_staticbox.Lower()
        sizer_24 = wx.StaticBoxSizer(self.sizer_24_staticbox, wx.VERTICAL)
        self.sizer_15_staticbox.Lower()
        sizer_15 = wx.StaticBoxSizer(self.sizer_15_staticbox, wx.VERTICAL)
        sizer_16 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_18 = wx.BoxSizer(wx.VERTICAL)
        sizer_21 = wx.BoxSizer(wx.VERTICAL)
        sizer_20 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_17 = wx.BoxSizer(wx.VERTICAL)
        self.sizer_8_staticbox.Lower()
        sizer_8 = wx.StaticBoxSizer(self.sizer_8_staticbox, wx.VERTICAL)
        sizer_9 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_11 = wx.BoxSizer(wx.VERTICAL)
        sizer_14 = wx.BoxSizer(wx.VERTICAL)
        sizer_13 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_10 = wx.BoxSizer(wx.VERTICAL)
        self.sizer_2_staticbox.Lower()
        sizer_2 = wx.StaticBoxSizer(self.sizer_2_staticbox, wx.VERTICAL)
        sizer_3 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_6 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_7 = wx.BoxSizer(wx.VERTICAL)
        sizer_4 = wx.BoxSizer(wx.VERTICAL)
        sizer_1.Add(self.label_1, 0, wx.LEFT | wx.RIGHT | wx.TOP | wx.ALIGN_CENTER_HORIZONTAL, 10)
        sizer_4.Add(self.label_2, 0, wx.LEFT, 10)
        sizer_4.Add(self.text_ctrl_1, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 5)
        sizer_3.Add(sizer_4, 1, wx.EXPAND, 0)
        sizer_7.Add(self.label_3, 0, wx.LEFT, 10)
        sizer_6.Add(sizer_7, 2, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_3.Add(sizer_6, 1, wx.EXPAND, 0)
        sizer_2.Add(sizer_3, 1, wx.EXPAND, 0)
        sizer_1.Add(sizer_2, 0, wx.ALL | wx.EXPAND, 10)
        sizer_24.Add(self.label_12, 0, wx.LEFT | wx.RIGHT | wx.ALIGN_CENTER_HORIZONTAL, 5)
        sizer_10.Add(self.label_4, 0, wx.LEFT, 10)
        sizer_10.Add(self.list_box_1, 1, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 5)
        sizer_9.Add(sizer_10, 1, wx.EXPAND, 0)
        sizer_13.Add(self.label_6, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_13.Add(self.combo_box_1, 1, wx.RIGHT, 5)
        sizer_11.Add(sizer_13, 0, wx.EXPAND, 0)
        sizer_14.Add(self.label_7, 0, wx.LEFT, 5)
        sizer_14.Add(self.text_ctrl_2, 1, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 5)
        sizer_11.Add(sizer_14, 1, wx.EXPAND, 0)
        sizer_9.Add(sizer_11, 4, wx.EXPAND, 0)
        sizer_8.Add(sizer_9, 1, wx.EXPAND, 0)
        sizer_24.Add(sizer_8, 1, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 5)
        sizer_17.Add(self.label_8, 0, wx.LEFT, 10)
        sizer_17.Add(self.list_box_2, 1, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 5)
        sizer_16.Add(sizer_17, 1, wx.EXPAND, 0)
        sizer_20.Add(self.label_10, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_20.Add(self.combo_box_2, 1, wx.RIGHT, 5)
        sizer_18.Add(sizer_20, 0, wx.EXPAND, 0)
        sizer_21.Add(self.label_11, 0, wx.LEFT, 5)
        sizer_21.Add(self.text_ctrl_3, 1, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 5)
        sizer_18.Add(sizer_21, 1, wx.EXPAND, 0)
        sizer_16.Add(sizer_18, 4, wx.EXPAND, 0)
        sizer_15.Add(sizer_16, 1, wx.EXPAND, 0)
        sizer_24.Add(sizer_15, 1, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 5)
        sizer_1.Add(sizer_24, 1, wx.LEFT | wx.RIGHT | wx.EXPAND, 10)
        sizer_23.Add(self.button_1, 0, wx.ALL, 10)
        sizer_23.Add(self.button_2, 0, wx.RIGHT | wx.TOP | wx.BOTTOM, 10)
        sizer_22.Add(sizer_23, 0, wx.EXPAND, 0)
        sizer_1.Add(sizer_22, 0, wx.ALIGN_RIGHT, 0)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade

    def onSelectFluidField(self, event):  # wxGlade: MyFrame.<event_handler>
        global beforeFluidField
        n = self.list_box_1.GetSelection()
        field = fluidFields[n][0]
        print field, _(u"fluid fieldの状態を表示します。")
        self.getFluidSettingContFromTextBox()
        self.showFluidInternalBoundaryField(field)
        beforeFluidField = field
 
    def onSelectSolidField(self, event):  # wxGlade: MyFrame.<event_handler>
        global beforeSolidField
        n = self.list_box_2.GetSelection()
        field = solidFields[n][0]
        print field, _(u"solid fieldの状態を表示します。")
        self.getSolidSettingContFromTextBox()
        self.showSolidInternalBoundaryField(field)
        beforeSolidField = field

    #cancel
    def onCansel(self, event):  # wxGlade: MyFrame.<event_handler>
        self.Destroy()

    #設定
    def onSetAllFields(self, event):  # wxGlade: MyFrame.<event_handler>
        self.getAllVariablesFromTextBox()
        stat = self.saveVariableToFile()
        if stat != "OK":
            return
        stat = self.replaceBoundaryFields()
        if stat != "OK":
            return
        self.Destroy()

# end of class MyFrame

    #  replaceBoundaryFields
    #    各fieldのinternalField、boundaruFieldを書き換える
    def replaceBoundaryFields(self):
        #各fieldの界面の境界条件が既に設定されているかどうかをチェック
        [error, mess] = checkAllFields()
        if error != "OK":
            title = _(u"警告")
            stat = self.okCancelDialog(title, mess)
            if stat == "CANCEL":
                return stat
        #fieldの置き換え
        [error, errFields] = replaceRegionFieldBoundaryConditions(caseDir, 
                        fluidRegions, solidRegions)
        if error == "OK":
            title = _(u"界面の境界条件設定")
            mess = _(u"領域間の境界条件とinternalFieldを再設定しました。\n")
            if len(errFields) > 0:
                mess += _(u"以下のfieldは、存在しない為、修正していません。\n")
                if len(errFields) > 5:
                    addMess = ", ".join(errFields[:5]) + "..."
                else:
                    addMess = ", ".join(errFields)
                mess += addMess
            self.okDialog(title, mess)
        else:
            title = _(u"エラー")
            self.errDialog(title, errFields)
        return error
        

    #  getAllVariablesFromTextBox
    #    dialog内の全てのデータを取得
    def getAllVariablesFromTextBox(self):
        global beforeFluidField, variables
        #変数の設定を取得
        variables = self.text_ctrl_1.GetValue()
        #fluid側の設定を取得
        n = self.list_box_1.GetSelection()
        field = self.list_box_1.GetString(n)
        beforeFluidField = field
        self.getFluidSettingContFromTextBox()
        #solid側の設定を取得
        n = self.list_box_2.GetSelection()
        field = self.list_box_2.GetString(n)
        beforeSolidField = field
        #全ての設定をtextBoxから取得
        self.getSolidSettingContFromTextBox()

    #  saveVariableToFile
    #    設定した変数の内容をDictに保存
    def saveVariableToFile(self):
        [stat, mess] = errorCheckInternalFieldName()
        if stat != "OK":
            self.errDialog(u"エラー", mess)
            return stat
        [stat, mess] = errorCheckBoundaryFieldName()
        if stat != "OK":
            self.errDialog(u"エラー", mess)
            return stat
        #設定内容を保存
        fileName = caseDir + "/system/regionWallBoundaryConditionsDict"
        f=open(fileName); dictCont=f.read(); f.close()
        dictCont = saveVariableToFile_variable(dictCont)
        dictCont = saveVariableToFile_internalField(dictCont)
        dictCont = saveVariableToFile_boundary(dictCont)
        f=open(fileName, "w"); f.write(dictCont); f.close()
        return "OK"


    #  getSolidSettingContFromTextBox
    #    textBoxのデータを取得
    def getSolidSettingContFromTextBox(self):
        global fluidFields, solidFields, solidBoundaryCont
        #internalFieldを取得
        intValue = self.combo_box_2.GetValue()
        if intValue == noChange:
            #switch off設定
            i = 0
            for fieldCont in solidFields:
                if fieldCont[0] == beforeSolidField:
                    solidFields[i][1][1] = "off"
                    break
                i += 1
        else:
            #switch on 設定
            variable = intValue.split()[-1][1:]
            i = 0
            for fieldCont in solidFields:
                if fieldCont[0] == beforeSolidField:
                    solidFields[i][1][0] = variable
                    solidFields[i][1][1] = "on"
                    break
                i += 1

        #boundaryFieldを取得
        boundary = self.text_ctrl_3.GetValue()
        i = 0
        for field in solidBoundaryCont:
            if field[0] == beforeSolidField:
                solidBoundaryCont[i][1] = boundary
                break
            i += 1


    #  getFluidSettingContFromTextBox
    #    textBoxのデータを取得
    def getFluidSettingContFromTextBox(self):
        global fluidFields, solidFields, fluidBoundaryCont
        #internalFieldを取得
        intValue = self.combo_box_1.GetValue()
        if intValue == noChange:
            i = 0
            for fieldCont in fluidFields:
                if fieldCont[0] == beforeFluidField:
                    fluidFields[i][1][1] = "off"
                    break
                i += 1
        else:
            variable = intValue.split()[-1][1:]
            #fieldと変数の関連を書き換え
            i = 0
            for fieldCont in fluidFields:
                if fieldCont[0] == beforeFluidField:
                    fluidFields[i][1][0] = variable
                    fluidFields[i][1][1] = "on"
                    break
                i += 1

        #boundaryFieldを取得
        boundary = self.text_ctrl_2.GetValue()
        i = 0
        for field in fluidBoundaryCont:
            if field[0] == beforeFluidField:
                fluidBoundaryCont[i][1] = boundary
                break
            i += 1    


    #  setVariablesTextBox
    #    変数をtextBoxに表示
    def setVariablesTextBox(self):
        self.text_ctrl_1.SetValue(variables)

    #  showFluidInternalBoundaryField
    #    internalField, boundaryFieldの内容を表示する
    def showFluidInternalBoundaryField(self, field):
        #internalFieldの表示
        self.setFluidComboBox(field)
        show = 0
        i = 0
        for setField in fluidFields:
            if setField[0] == field:
                if isString(setField[1][1]) == True:
                    show = 1
                    break
            i += 1
        if show == 0:
            self.combo_box_1.SetSelection(0)
        else:
            self.combo_box_1.SetSelection(1)
        #boundaryの表示
        boundary = ""
        for bCont in fluidBoundaryCont:
            if field == bCont[0]:
                boundary = bCont[1]
                break
        self.text_ctrl_2.SetValue(boundary)

    #  showSolidInternalBoundaryField
    #    internalField, boundaryFieldの内容を表示する
    def showSolidInternalBoundaryField(self, field):
        #internalFieldの表示
        self.setSolidComboBox(field)
        show = 0
        i = 0
        for setField in solidFields:
            if setField[0] == field:
                if isString(setField[1][1]) == True:
                    show = 1
                    break
            i += 1
        if show == 0:
            self.combo_box_2.SetSelection(0)
        else:
            self.combo_box_2.SetSelection(1)
        #boundaryの表示
        boundary = ""
        for bCont in solidBoundaryCont:
            if field == bCont[0]:
                boundary = bCont[1]
                break
        self.text_ctrl_3.SetValue(boundary)

    #  setFieldsListBox
    #    ListBoxにfirldをセット
    def setFieldsListBox(self):
        global beforeFluidField, beforeSolidField
        #fluid側セット
        fields = []
        for fieldCont in fluidFields:
            fields.append(fieldCont[0])
        self.list_box_1.Clear()
        self.list_box_1.AppendItems(fields)
        self.list_box_1.SetSelection(0)
        beforeFluidField = fields[0]
        #solid側セット
        fields = []
        for fieldCont in solidFields:
            fields.append(fieldCont[0])
        self.list_box_2.Clear()
        self.list_box_2.AppendItems(fields)
        self.list_box_2.SetSelection(0)
        beforeSolidField = fields[0]

    #  setFluidComboBox
    #    fluidComboBoxにデータセット
    def setFluidComboBox(self, field):
        variables = []
        variables.append(noChange)
        for fieldCont in fluidFields:
            if fieldCont[0] == field:
                variables.append(uniform+fieldCont[1][0])
                break
        self.combo_box_1.Clear()
        self.combo_box_1.AppendItems(variables)

    #  setSolidComboBox
    #    solidComboBoxにデータセット
    def setSolidComboBox(self, field):
        variables = []
        variables.append(noChange)
        for fieldCont in solidFields:
            if fieldCont[0] == field:
                variables.append(uniform+fieldCont[1][0])
                break
        self.combo_box_2.Clear()
        self.combo_box_2.AppendItems(variables)


    #  setComoBox
    #    combpBoxにデータセット
    def setComboBox(self):
        #fluid側セット
        n = self.list_box_1.GetSelection()
        field = fluidFields[n][0]
        variables = []
        variables.append(noChange)
        for fieldCont in fluidFields:
            if isString(fieldCont[1][1]) == True:
                variables.append(uniform+fieldCont[1][0])
                break
        self.combo_box_1.Clear()
        self.combo_box_1.AppendItems(variables)
        #solid側セット
        n = self.list_box_2.GetSelection()
        field = solidFields[n][0]
        variables = []
        variables.append(noChange)
        for fieldCont in solidFields:
            if isString(fieldCont[1][1]) == True:
                variables.append(uniform+fieldCont[1][0])
        self.combo_box_2.Clear()
        self.combo_box_2.AppendItems(variables)

    #  setBoundatyTextBox
    #    boundaryをtextBoxにセット
    def setBoundatyTextBox(self):
        #fluid側セット
        n = self.list_box_1.GetSelection()
        field = fluidFields[n][0]
        boundary = ""
        for bCont in fluidBoundaryCont:
            if field == bCont[0]:
                boundary = bCont[1]
                break
        self.text_ctrl_2.SetValue(boundary)
        #solid側をセット
        n = self.list_box_2.GetSelection()
        field = solidFields[n][0]
        boundary = ""
        for bCont in solidBoundaryCont:
            if field == bCont[0]:
                boundary = bCont[1]
                break
        self.text_ctrl_3.SetValue(boundary)



    def okDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_INFORMATION) 
        dlg.ShowModal()
        dlg.Destroy()

    def okCancelDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.CANCEL | wx.ICON_INFORMATION) 
        res = dlg.ShowModal()
        if res == wx.ID_OK:
            ans = "OK"
        else:
            ans = "CANCEL"
        dlg.Destroy()
        return ans

    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_HAND) 
        dlg.ShowModal()
        dlg.Destroy()



#  isString
#    文字列をチェック
def isString(string):
    if (string == "yes" or string == "Yes" or string == "YES" or
        string == "on" or string == "On" or string == "ON" or
        string == "true" or string == "True" or string == "TRUE"):
        ans = True
    else:
        ans = False
    return ans


#  errorCheckInternalFieldName
#    internalFieldで使用する変数名をチェック
def errorCheckInternalFieldName():

    def errorCheck(fluidSolid, intConts, variNames):
        errCont = ""
        for intCont in intConts:
            if isString(intCont[1][1]) == True:
                same = 0
                intName = intCont[1][0]
                for variName in variNames:
                    if intName == variName:
                        same = 1
                        break
                if same == 0:
                    errCont = [fluidSolid, intCont[0], intCont[1][0]]
                    break
        return errCont

    def makeMessage(errorCont):
        mess  = errorCont[0] + _(u": ") + errorCont[1]
        mess += _(u" internalField で使用している変数「")
        mess += errorCont[2] + _(u"」は、変数設定エリア内に定義されていません。")
        return mess        

    #変数名を取得
    variableList = variables.split("\n")
    variNames = []
    for line in variableList:
        varis = line.split()
        if len(varis) > 1:
            variNames.append(varis[0])
    #fluid側
    errorCont = errorCheck("fluid", fluidFields, variNames)
    if len(errorCont) != 0:
        return ["NG", makeMessage(errorCont)]
    #solid側
    errorCont = errorCheck("solid", solidFields, variNames)
    if len(errorCont) != 0:
        return ["NG", makeMessage(errorCont)]
    return ["OK", ""]


#  errorCheckBoundaryFieldName
#    boundaryFieldで使用する変数名のエラーチェック
def errorCheckBoundaryFieldName():

    def errorCheck(fluidSolid, boundaryConts, variNames):
        errorCont = ""
        for boundCont in boundaryConts:
            text = boundCont[1]
            n = text.find(" $")
            if n >= 0 and text[n:n+3] != " $:":
                [keyword, p] = getFoamContents.getKeywordMem(text, n)
                boundName = keyword[1:]
                same = 0
                for variName in variNames:
                    if boundName == variName:
                        same = 1
                        break
                if same == 0:
                    errorCont = [fluidSolid, boundCont[0], boundName]
                    break
        return errorCont

    def makeMessage(errorCont):
        mess  = errorCont[0] + _(u": ") + errorCont[1]
        mess += _(u" boundaryField で使用している変数「")
        mess += errorCont[2] + _(u"」は、変数設定エリア内に定義されていません。")
        return mess

    #変数名を取得
    variableList = variables.split("\n")
    variNames = []
    for line in variableList:
        varis = line.split()
        if len(varis) > 1:
            variNames.append(varis[0])
    #fluid側
    errorCont = errorCheck("fluid", fluidBoundaryCont, variNames)
    if len(errorCont) != 0:
        return ["NG", makeMessage(errorCont)]
    #solid側
    errorCont = errorCheck("solid", solidBoundaryCont, variNames)
    if len(errorCont) != 0:
        return ["NG", makeMessage(errorCont)]
    return ["OK", ""]

#  checkAllFields
#    各fieldのboundaryFieldをチェックする
#    各fieldの界面の境界条件が既に設定されているかどうかチェック
def checkAllFields():

    #  checkBoundaryField
    #    fieldの境界条件をチェック
    def checkBoundaryField(regName, fieldName):
        error = ""
        boundaryCont = ""
        if len(glob.glob(fieldName)) == 0:
            return ""
        [ascii, data] = getFoamContents.readFileSeparate(fieldName)
        [lineCont, p, kind] = getFoamContents.get1lineMem(ascii, 0)
        while lineCont != "":
            [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
            if keyword == "boundaryField":
                [boundaryCont, pp] = getFoamContents.getMiddlePairMem(lineCont, 0)
                break
            [lineCont, p, kind] = getFoamContents.get1lineMem(ascii, p)
        if boundaryCont != "":
            [lineCont, p, kind] = getFoamContents.get1lineMem(boundaryCont, 0)
            while lineCont != "":
                [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
                if keyword.find(regName + "_to_") >= 0:
                    error = regName
                    break
                [lineCont, p, kind] = getFoamContents.get1lineMem(boundaryCont, p)
        return error

    #処理------------------------
    timeFolder = pyTreeFoam.getTimeFolders(caseDir)[0]
    #fluid側のチェック
    fluidErrRegions = []
    for regName in fluidRegions:
        flag = 0
        fieldDir = caseDir + "/" + timeFolder + "/" + regName
        for fieldCont in fluidFields:
            field = fieldCont[0]
            fieldName = fieldDir + "/" + field
            error = checkBoundaryField(regName, fieldName)
            if error != "":
                fluidErrRegions.append(regName)
                break
    #solid側のチェック
    solidErrRegions = []
    for regName in solidRegions:
        fieldDir = caseDir + "/" + timeFolder + "/" + regName
        for fieldCont in solidFields:
            field = fieldCont[0]
            fieldName = fieldDir + "/" + field
            #patch名に「_to_」の文字があるかどうかチェック
            error = checkBoundaryField(regName, fieldName)
            if error != "":
                solidErrRegions.append(regName)
                break
    #終了処理
    if len(fluidErrRegions) == 0 and len(solidErrRegions) == 0:
        mess = ""
        stat = "OK"
    else:
        stat = "NG"
        mess  = _(u"以下のregion内には、既に界面の境界条件が設定されています。\n")
        mess += _(u"界面の境界条件を再設定しますか？\n")
        if len(fluidErrRegions) != 0:
            mess += _(u"fluid:")
            if len(fluidErrRegions) > 5:
                mess += ", ".join(fluidErrRegions[:5]) + "..."
            else:
                mess += ", ".join(fluidErrRegions)
        if len(solidErrRegions) != 0:
            mess += _(u"\nsolid:")
            if len(solidErrRegions) > 5:
                mess += ", ".join(solidErrRegions[:5]) + "..."
            else:
                mess += ", ".join(solidErrRegions)
    return [stat, mess]
    
#  saveVariableToFile_variable
#    変数定義をfileに保存
def saveVariableToFile_variable(contents):
    varList = variables.split("\n")
    corrVar = []
    for var in varList:
        if len(var) > 0:
            words = var.split()
            name = setTab(words[0], 16)
            value = " ".join(words[1:])
            corrVar.append("    " + name + value)
    corrVariables = "\n".join(corrVar)
    newCont  = "variableSetting\n"
    newCont += "{\n"
    newCont += corrVariables + "\n"
    newCont += "}"
    p = getFoamContents.skipFoamFileMem(contents, 0)
    [newCont, p, keyword] = getFoamContents.replace1lineMem(contents, p, newCont)
    return newCont


#  saveVariableToFile_internalField
#    internalFieldの設定をfileに保存
def saveVariableToFile_internalField(contents):
    
    def deleteNullInternalData(conts):
        newCont = []
        for cont in conts:
            if len(cont[1][0].split()) != 0:
                if isString(cont[1][1]) == True:
                    newCont.append(cont)
        return newCont

    p = getFoamContents.skipFoamFileMem(contents, 0)
    newCont  = "internalFields\n"
    newCont += "{\n"
    #fluid側を設定
    newCont += "    fluidRegions\n"
    newCont += "    {\n"
    internalData = deleteNullInternalData(fluidFields)
    for fieldCont in internalData:
        name = fieldCont[0]
        line  = "    " + setTab(name, 12) + fieldCont[1][0] + ";\n"
        newCont += "    " + line
    newCont += "    }\n"
    #solid側を設定
    newCont += "    solidRegions\n"
    newCont += "    {\n"
    internalData = deleteNullInternalData(solidFields)
    for fieldCont in internalData:
        name = fieldCont[0]
        line  = "    " + setTab(name, 12) + fieldCont[1][0] + ";\n"
        newCont += "    " + line
    newCont += "    }\n"
    newCont += "}"
    [newCont, p, kind] = getFoamContents.replace1lineMem(contents, p, newCont)
    return newCont

#  setTab
#    wordの長さを空白を入れて揃える
def setTab(word, tab):
    if len(word) < tab:
        newWord = word + " "*(tab - len(word))
    else:
        newWord = word + " "
    return newWord

#  saveVariableToFile_boundary
#    boundaryのデータをfileに保存
def saveVariableToFile_boundary(contents):

    def deleteNullBoundaryCont(conts):
        newCont = []
        for cont in conts:
            line = pyTreeFoam.compressSPCR(cont[1])
            if not (line == "" or line == "\n" or line == " \n" or
                line == noChange):
                newCont.append(cont)
        return newCont

    p = getFoamContents.skipFoamFileMem(contents, 0)
    newCont  = "regionWallBoundaryConditions\n"
    newCont += "{\n"
    newCont += "    fluidRegions\n"
    newCont += "    {\n"
    #fluid側
    fieldData = deleteNullBoundaryCont(fluidBoundaryCont)
    for fieldCont in fieldData:
        newCont += "        " + fieldCont[0] + "\n"
        newCont += "        {\n"
        lines = fieldCont[1].split("\n")
        for line in lines:
            newCont += "            " + line + "\n"
        newCont += "        }\n\n"
    newCont += "    }\n"
    #solid側
    newCont += "    solidRegions\n"
    newCont += "    {\n"
    fieldData = deleteNullBoundaryCont(solidBoundaryCont)
    for fieldCont in fieldData:
        newCont += "        " + fieldCont[0] + "\n"
        newCont += "        {\n"
        lines = fieldCont[1].split("\n")
        for line in lines:
            newCont += "            " + line + "\n"
        newCont += "        }\n\n"
    newCont += "    }\n"
    newCont += "}"
    [newCont, p, kind] = getFoamContents.replace1lineMem(contents, p, newCont)
    return newCont


#  getIncludeDirFromDict
#    includeDirを取得
def getIncludeDirFromDict(dictCont):
    global includeDir, includeDirOrg
    p = getFoamContents.skipFoamFileMem(dictCont, 0)
    lineCont = " "; keyword = " "
    while lineCont != "" and keyword != "includeDir":
        [lineCont, p, kind] = getFoamContents.get1lineMem(dictCont, p)
        [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
    if lineCont != "" and kind == "line":
        includeDir = (lineCont.split()[1]).split(";")[0]
        includeDirOrg = includeDir
        return ["OK", ""]
    else:
        return ["NG", _(u"Dict内にincludeDirがありません。")]


#  getVariableContentsFromDict
#    変数を取得
def getVariableContentsFromDict(dictCont):
    global variables
    p = getFoamContents.skipFoamFileMem(dictCont, 0)
    lineCont = " "; keyword = " "
    while lineCont != "" and keyword != "variableSetting":
        [lineCont, p, kind] = getFoamContents.get1lineMem(dictCont, p)
        [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
    if keyword != "variableSetting":
        return ["NG", _(u"Dict内にvariableSettingがありません。")]

    [contents, p] = getFoamContents.getMiddlePairMem(lineCont, 0)
    variables = ""
    [lineCont, p, kind] = getFoamContents.get1lineMem(contents, 0)
    while lineCont != "" and p<len(contents):
        if kind == "line":
            variables += lineCont + "\n"
        [lineCont, p, kind] = getFoamContents.get1lineMem(contents, p)
    return ["OK", ""]


#  getInternalFieldsFromDict
#    field名とfieldに対応する変数名
#    internalFieldを変数に設定するfield名
#       を取得
def getInternalFieldsFromDict(dictCont):
    global fluidFields, solidFields

    #  getNameCont
    def getNameCont(name, dictCont):
        #nameを取得
        lineCont = " "; keyword = " "; p = 0;
        while lineCont != "" and keyword != name:
            [lineCont, p, kind] = getFoamContents.get1lineMem(dictCont, p)
            [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
        [cont, p] = getFoamContents.getMiddlePairMem(lineCont, 0)
        return cont

    #  operationFields
    def operationFields(cont):
        ans = []
        [fieldCont, p, kind] = getFoamContents.get1lineMem(cont, 0)
        while fieldCont != "" and p<len(cont):
            field = fieldCont.split()[0]
            variable = fieldCont.split()[1]
            if variable[-1] == ";":
                variable = variable[:-1]
            ans.append([field, [variable, "on"]])
            [fieldCont, p, kind] = getFoamContents.get1lineMem(cont, p)
        return ans

    #処理
    p = getFoamContents.skipFoamFileMem(dictCont, 0)
    lineCont = " "; keyword = " "
    while lineCont != "" and keyword != "internalFields":
        [lineCont, p, kind] = getFoamContents.get1lineMem(dictCont, p)
        [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
    if lineCont == "":
        return ["NG", _(u"Dict内にinternalFieldsの設定がありません。")]
    [contents, p] = getFoamContents.getMiddlePairMem(lineCont, 0)
    fluidCont = getNameCont("fluidRegions", contents)
    solidCont = getNameCont("solidRegions", contents)
    fluidFields = operationFields(fluidCont)
    solidFields = operationFields(solidCont)
    return ["", ""]



#  getBoundaryConditionsFromDict
#    境界条件を取得
def getBoundaryConditionsFromDict(dictCont):
    global fluidBoundaryCont, solidBoundaryCont

    #  getNameCont
    def getNameCont(name, dictCont):
        #nameを取得
        lineCont = " "; keyword = " "; p = 0;
        while lineCont != "" and keyword != name:
            [lineCont, p, kind] = getFoamContents.get1lineMem(dictCont, p)
            [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
        [cont, p] = getFoamContents.getMiddlePairMem(lineCont, 0)
        return cont

    #  boundaryConditions
    def boundaryConditions(nameCont):
        boundaryCont = []
        [fieldCont, p, kind] = getFoamContents.get1lineMem(nameCont, 0)
        while fieldCont != "" and p<len(nameCont):
            [field, pp] = getFoamContents.getKeywordMem(fieldCont, 0)
            [boundary, pp] = getFoamContents.getMiddlePairMem(fieldCont, 0)
            boundary = pyTreeFoam.compressSPCR(boundary)
            boundaryCont.append([field, boundary])
            [fieldCont, p, kind] = getFoamContents.get1lineMem(nameCont, p)
        return boundaryCont

    #処理
    p = getFoamContents.skipFoamFileMem(dictCont, 0)
    lineCont = " "; keyword = " "
    while lineCont != "" and keyword != "regionWallBoundaryConditions":
        [lineCont, p, kind] = getFoamContents.get1lineMem(dictCont, p)
        [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
    if lineCont == "":
        return ["NG", _(u"Dict内にregionWallBoundaryConditionsの設定がありません。")]

    [boundaryCont, p] = getFoamContents.getMiddlePairMem(lineCont, 0)
    #fluid側を取得
    name = "fluidRegions"
    contents = getNameCont(name, boundaryCont)
    fluidBoundaryCont = boundaryConditions(contents)
    #solid側を取得
    name = "solidRegions"
    contents = getNameCont(name, boundaryCont)
    solidBoundaryCont = boundaryConditions(contents)

#
#  checkOperationFields
#    操作するfield名をinternalField, boundaryFieldから確認し、足りないfieldを追加する。
def checkOperationField():
    global fluidFields, fluidBoundaryCont, solidFields, solidBoundaryCont

    def addInFields(outFields, inFields):
        addFields = []
        for outField in outFields:
            same = 0
            for inField in inFields:
                if outField[0] == inField[0]:
                    same = 1
                    break
            if same == 0:
                addFields.append([outField[0], []])
        inFields += addFields
        return inFields

    #fluid側
    #  fluidFieldsをチェック
    fluidFields = addInFields(fluidBoundaryCont, fluidFields)
    for fluidField in fluidFields:
        if len(fluidField[1]) == 0:
            fluidField[1] = [" ", "off"]
    #  fluidBoundaryをチェック
    fluidBoundaryCont = addInFields(fluidFields, fluidBoundaryCont)
    for fluidBoundField in fluidBoundaryCont:
        if len(fluidBoundField[1]) == 0:
            fluidBoundField[1] = ""
    fluidFields.sort()
    #solid側
    #  solidFieldsをチェック
    solidFields = addInFields(solidBoundaryCont, solidFields)
    for solidField in solidFields:
        if len(solidField[1]) == 0:
            solidField[1] = [" ", "off"]
    #  fluidBoundaryをチェック
    solidBoundaryCont = addInFields(solidFields, solidBoundaryCont)
    for solidBoundField in solidBoundaryCont:
        if len(solidBoundField[1]) == 0:
            solidBoundField[1] = ""
    solidFields.sort()


#  initialize
#    初期化
def initialize(caseDir):
    global fluidRegions, solidRegions
    global uniform, noChange
    #各region名を取得
    [fluidRegions, solidRegions] = pyTreeFoam.getZonesInRegionProperties(caseDir)
    #dict読み込み
    dictCont = readDictFile(caseDir)
    #includeDirを取得
    error = getIncludeDirFromDict(dictCont)
    #変数を取得
    error = getVariableContentsFromDict(dictCont)
    #internalFieldの設定読み込み
    error = getInternalFieldsFromDict(dictCont)
    #境界条件の読み込み
    error = getBoundaryConditionsFromDict(dictCont)
    #field名のチェック
    checkOperationField()
    #変数の設定
    uniform = _(u"uniform $")
    noChange = _(u"(変更せず)")

#
#  readDictFile
#    DictFileの読み込み
def readDictFile(caseDir):
    sName = "regionWallBoundaryConditionsDict"
    fileName = caseDir + "/system/" + sName
    if len(glob.glob(fileName)) == 0:
        #dictが存在しない場合、defaultのdictFileをコピーする
        OFversion = pyTreeFoam.readConfigTreeFoam()[0]
        treeFoamPath = os.getenv("TreeFoamPath")
        orgName = treeFoamPath + "/data/multiRegionDB/" + sName
        names = glob.glob(orgName+"*")
        names.sort()
        dictFileName = ""
        for name in names:
            if name[-1] != "~" and name[0] != ".":
                dictName = name.split("/")[-1]
                readName = sName + "_" + OFversion
                if dictName <= readName:
                    dictFileName = dictName
        orgName = treeFoamPath + "/data/multiRegionDB/" + dictFileName
        distName = caseDir + "/system/" + sName
        comm = "cp " + orgName + " " + distName
        os.system(comm)
        print comm
        print _(u"警告:regionWallBoundaryConditionsDictファイルが存在しなかったので、systemフォルダにコピーしました。")
    #dict読み込み
    f=open(fileName); cont=f.read(); f.close()
    return cont

#
#  replaceRegionFieldBoundaryConditions
#    region内のboundaryFieldのpatchを再設定する
def replaceRegionFieldBoundaryConditions(caseDir, fluidRegs, solidRegs):

    #  deleteErrVariable
    #    余分な変数名を削除
    #    （includeFile内の変数名と同じ変数名は削除）
    def deleteErrVariable(cont, variablesLine):
        variables = variablesLine.split("\n")
        #pointerをdimensionsまで進める
        p = getFoamContents.skipFoamFileMem(cont, 0)
        lineCont = " "; keyword = " "
        while lineCont != "" and keyword != "dimensions":
            [lineCont, p, kind] = getFoamContents.get1lineMem(cont, p)
            [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
        #dimensionsまでを保存
        newAscii = cont[:p] + "\n"
        #include内の変数（variables）と同じ変数は削除する
        lineCont = " "; keyword = " "
        while lineCont != "" and keyword != "internalField":
            [lineCont, p, kind] = getFoamContents.get1lineMem(cont, p)
            [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
            if kind == "line" and keyword != "internalField":
                name = lineCont.split()[0]
                same = 0
                for variable in variables:
                    if len(variable) > 0:
                        if variable.split()[0] == name:
                            same = 1
                            break
                if same == 0:
                    newAscii += lineCont + "\n"
            else:
                if keyword == "internalField":
                    newAscii += "\n" + lineCont
                else:
                    newAscii += lineCont + "\n"
        newAscii += cont[p:]
        return newAscii

    #  deleteErrIncludeFile
    #    余分なincludeFileを削除
    #    （同じfile名でincludeDirが異なっているincludeFile）
    def deleteErrIncludeFile(cont, includeFiles):
        p = getFoamContents.skipFoamFileMem(cont, 0)
        lineCont = " "; keyword = " "
        while lineCont != "" and keyword != "dimensions":
            [lineCont, p, kind] = getFoamContents.get1lineMem(cont, p)
            [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
        newAscii = cont[:p] + "\n"
        lineCont = " "; keyword = " "
        while lineCont != "" and keyword != "internalField":
            [lineCont, p, kind] = getFoamContents.get1lineMem(cont, p)
            [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
            if kind == "include":
                incFile = lineCont.split()[1]
                name = incFile.split("/")[-1]
                if (name == 'variableSetting"' or
                    name == 'boundaryConditionsFluid"' or
                    name == 'boundaryConditionsSolid"'):
                    if (incFile == includeFiles[0] or
                        incFile == includeFiles[1]):
                        newAscii += lineCont + "\n"
            else:
                if keyword == "internalField":
                    newAscii += "\n" + lineCont
                else:
                    newAscii += lineCont + "\n"
        newAscii += cont[p:]
        return newAscii

    #  replaceField
    #    fieldの置き換え
    def replaceField(fluidSolid, fieldName, intCont):
        #fieldの読み込み
        [ascii, data] = getFoamContents.readFileSeparate(fieldName)
        p = getFoamContents.skipFoamFileMem(ascii, 0)
        #includeの置き換え
        #  includeFileを設定
        incDir = includeDirOrg
        if incDir[0] == '"':
            incDir = includeDirOrg.split('"')[1]
        includeFiles = ['"' + incDir + '/variableSetting"']
        if fluidSolid == "fluid":
            includeFiles.append('"' + incDir + '/boundaryConditionsFluid"')
        else:
            includeFiles.append('"' + incDir + '/boundaryConditionsSolid"')
        #  pointerをdimensionsの次まで進める
        [lineCont, p, kind] = getFoamContents.get1lineMem(ascii, p)
        while lineCont != "":
            [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
            if keyword == "dimensions":
                ps = p+1
                break
            [lineCont, p, kind] = getFoamContents.get1lineMem(ascii, p)
        #  同じincludeFileが存在しているかどうかチェック
        isInclude = [False, False]
        [lineCont, p, kind] = getFoamContents.get1lineMem(ascii, p)
        [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
        while lineCont != "" and keyword != "internalField":
            if kind == "include":
                incFile = lineCont.split()[1]
                if incFile == includeFiles[0]:
                    isInclude[0] = True
                if incFile == includeFiles[1]:
                    isInclude[1] = True
                ps = p
            [lineCont, p, kind] = getFoamContents.get1lineMem(ascii, p)
            [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
        #  includeFileを設定
        addLines = ""
        if isInclude[0] == False:
            addLines += '#include ' + includeFiles[0] + "\n"
        if isInclude[1] == False:
            addLines += '#include ' + includeFiles[1] + "\n"
        header = ascii[:ps]
        footer = ascii[ps:]
        ascii = header + addLines + footer
        #  余分なincludeFileを削除
        #  （同じfile名でincludeDirが異なっているincludeFile）
        ascii = deleteErrIncludeFile(ascii, includeFiles)
        #  余分な変数名を削除
        #  （includeFile内の変数名と同じ変数名は削除）
        ascii = deleteErrVariable(ascii, variables)
        #pointerを保存
        pss = getFoamContents.skipFoamFileMem(ascii, 0)
        pss = getFoamContents.getKeywordPointerMem("dimensions", ascii, pss)
        #internalField置き換え
        internalVar = intCont[0]
        if isString(intCont[1]) == True:
            ps = getFoamContents.getKeywordPointerMem("internalField", ascii, pss)
            [lineCont, p, kind] = getFoamContents.get1lineMem(ascii, ps)
            [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
            [keyword, pp] = getFoamContents.getKeywordMem(lineCont, pp)
            if keyword == "uniform":
                line = "internalField   uniform $" + internalVar + ";"
                [ascii, p, keyword] = getFoamContents.replace1lineMem(ascii, ps, line)
        #boundaryの書き換え
        field = fieldName.split("/")[-1]
        ps = getFoamContents.getKeywordPointerMem("boundaryField", ascii, pss)
        header = ascii[:ps] + "boundaryField\n{\n"
        [boundCont, pp] = getFoamContents.getMiddlePairMem(ascii, ps)
        footer = "}" + ascii[pp:]
        newCont = ""
        pattern = '".*._to_.*"'
        [lineCont, p, kind] = getFoamContents.get1lineMem(boundCont, 0)
        [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
        while lineCont != "":
            if pyTreeFoam.isMatchName(keyword, pattern) == False:
                newCont += "    " + lineCont + "\n"
            [lineCont, p, kind] = getFoamContents.get1lineMem(boundCont, p)
            [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
        line  = "    " + pattern + "\n"
        line += "    {\n"
        line += "        $:wallToRegion." + field + ";\n"
        line += "    }\n"
        newCont += line
        ascii = header + newCont + footer
        #再設定したfieldを保存
        getFoamContents.writeFileSeparate(fieldName, [ascii, data])

    #処理----------------------
    errFields = []
    #Dictの読み込み
    initialize(caseDir)
    #includeFileの作成
    error = createIncludeFiles(caseDir)
    if error[0] != "OK":
        return error

    #fluid側の設定
    timeFolder = pyTreeFoam.getTimeFolders(caseDir)[0]
    error = ""
    for regName in fluidRegs:
        for fieldCont in fluidFields:
            field = fieldCont[0]
            fieldName = caseDir + "/" + timeFolder + "/" + regName + "/" + field
            if len(glob.glob(fieldName)) == 0:
                #存在しないfield名を保存
                errFields.append(fieldName.split("/")[-1])
            else:
                #fieldの置き換え（修正）
                replaceField("fluid", fieldName, fieldCont[1])
    #solid側の設定
    for regName in solidRegs:
        for fieldCont in solidFields:
            field = fieldCont[0]
            fieldName = caseDir + "/" + timeFolder + "/" + regName + "/" + field
            if len(glob.glob(fieldName)) == 0:
                #存在しないfield名を保存
                errFields.append(fieldName.split("/")[-1])
            else:
                #fieldの置き換え（修正）
                replaceField("solid", fieldName, fieldCont[1])
    #errFieldsの修正
    errFields.sort()
    fields = []
    name = ""
    for errName in errFields:
        if name != errName:
            fields.append(errName)
            name = errName            
    return ["OK", fields]

#  getAbsPath
#    絶対pathに変換
def getAbsPath(caseDir, cont):
    #環境変数を取得
    sp = cont.find("${")
    if sp >= 0:
        [envPath, p] = getFoamContents.getMiddlePairMem(cont,sp)
        if os.getenv(envPath) != None:
            cont = cont[:sp] + os.getenv(envPath) + cont[p:]
        else:
            if envPath == "FOAM_CASE":
                # $FOAM_CASEは、bashの環境変数ではないのでここでセット
                cont = cont[:sp] + caseDir + cont[p:]
    if cont[0] != "/":
        cont = caseDir + "/" + cont
    return cont


#
#  createIncludeFiles
#    includeFileを指定されたdirectory内に作成する。
def createIncludeFiles(caseDir):
    global includeDir

    #  deleteHeadSp
    #    行頭の空白4ヶを削除
    def deleteHeadSp(cont):
        lines = cont.split("\n")
        i = 0
        for line in lines:
            if line[:4] == "    ":
                lines[i] = line[4:]
            i += 1
        newCont = "\n".join(lines)
        return newCont

    #  getIncludeDir
    #    includeDirを取得
    def getIncludeDir(dictCont):
        pCont = getFoamContents.skipFoamFileMem(dictCont, 0)
        [lineCont, p, kind] = getFoamContents.get1lineMem(dictCont, pCont)
        [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
        while lineCont != "" and keyword != "includeDir":
            [lineCont, p, kind] = getFoamContents.get1lineMem(dictCont, p)
            [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
        if keyword == "includeDir":
            includeDir = lineCont.split()[1]
            if includeDir[-1] == ";":
                includeDir = includeDir[:-1]
            includeDir = includeDir.split('"')[1]
            includeDir = getAbsPath(caseDir, includeDir)
        else:
            includeDir = ""
        return includeDir

    #dict読み込み
    dictCont = readDictFile(caseDir)
    pCont = getFoamContents.skipFoamFileMem(dictCont, 0)
    #header, footer作成
    version = pyTreeFoam.readConfigTreeFoam()[0]
    header = setFoamContents.makeFoamHeaderVersion(version)
    header += setFoamContents.makeFoamFile("2.2", "ascii", "dictionary", "",
            "regionWallBoundaryConditionsDict")
    footer = setFoamContents.makeFooter()
    #includeDirを取得
    includeDir = getIncludeDir(dictCont)
    if includeDir != "":
        if len(glob.glob(includeDir)) == 0:
            comm = "mkdir -p " + includeDir
            os.system(comm)
    else:
        error = ["NG", Dict + _(u"内にincludeDirが設定されていません。")]
        return error
    #variableSettingを作成
    [lineCont, p, kind] = getFoamContents.get1lineMem(dictCont, pCont)
    [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
    while lineCont != "" and keyword != "variableSetting":
        [lineCont, p, kind] = getFoamContents.get1lineMem(dictCont, p)
        [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
    if keyword == "variableSetting":
        [variCont, pp] = getFoamContents.getMiddlePairMem(lineCont, 0)
        #行頭の空白4ヶを削除
        variCont = deleteHeadSp(variCont)
        variCont = header + variCont + footer
        fileName = includeDir + "/variableSetting"
        f=open(fileName, "w"); f.write(variCont); f.close()
    else:
        error = ["NG", Dict + _(u"内にvariableSettingが設定されていません。")]
        return error
    #boundaryConditionsを作成
    lineCont = " "; keyword = " "
    while lineCont != "" and keyword != "regionWallBoundaryConditions":
        [lineCont, p, kind] = getFoamContents.get1lineMem(dictCont, p)
        [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
    if lineCont != "":
        [variCont, pp] = getFoamContents.getMiddlePairMem(lineCont, 0)
        #fluid側を作成
        lineCont = " "; keyword = " "; pp = 0
        while lineCont != "" and keyword != "fluidRegions":
            [lineCont, pp, kind] = getFoamContents.get1lineMem(variCont, pp)
            [keyword, ppp] = getFoamContents.getKeywordMem(lineCont, 0)
        if lineCont != "":
            [fluidCont, ppp] = getFoamContents.getMiddlePairMem(lineCont, 0)
            #行頭の空白4ヶを削除
            fluidCont = deleteHeadSp(fluidCont)
            fluidCont = header + "wallToRegion\n{\n" + fluidCont + "}\n" + footer
            fileName = includeDir + "/boundaryConditionsFluid"
            f=open(fileName, "w"); f.write(fluidCont); f.close()
        else:
            error = ["NG", Dict + _(u"内にregionWallBoundaryConditions.fluidRegionsが設定されていません。")]
            return error
        #solid側を作成
        lineCont = " "; keyword = " "; pp = 0
        while lineCont != "" and keyword != "solidRegions":
            [lineCont, pp, kind] = getFoamContents.get1lineMem(variCont, pp)
            [keyword, ppp] = getFoamContents.getKeywordMem(lineCont, 0)
        if lineCont != "":
            [solidCont, ppp] = getFoamContents.getMiddlePairMem(lineCont, 0)
            solidCont = deleteHeadSp(solidCont)
            solidCont = header + "wallToRegion\n{\n" + solidCont + "}\n" + footer
            fileName = includeDir + "/boundaryConditionsSolid"
            f=open(fileName, "w"); f.write(solidCont); f.close()
        else:
            error = ["NG", Dict + _(u"内にregionWallBoundaryConditions.solidRegionsが設定されていません。")]
            return error
    else:
        error = ["NG", Dict + _(u"内にregionWallBoundaryConditionsが設定されていません。")]
        return error
    return ["OK", ""]



if __name__ == "__main__":
    import gettext
    treeFoamPath = os.environ["TreeFoamPath"]
    gettext.install("treefoam", treeFoamPath + "/data/locale")

    caseDir = sys.argv[1]
    initialize(caseDir)
    app = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, wx.ID_ANY, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()
