#!/usr/bin/env python
# -*- coding: UTF-8 -*-
#
#   createLayersDDialog.py
#
#       meshにlayerを追加するためのsnappyHexMeshDictを作成する
#
#   14/08/31    新規作成
#      09/07    修正
#      09/08    decomposeParDictのコピーを追加
#      09/09    initialize, createLayerPatch:バグ修正
#

#
# generated by wxGlade 0.6.7+ on Sat Aug 30 09:50:38 2014
#

import wx
import os
import glob
import pyTreeFoam
import getFoamContents


# begin wxGlade: extracode
# end wxGlade

caseDir = ""
meshDir = ""
patchNames = []
layerPatchNames = []
layerSetting = []

#
#  Show
#    dialogの表示
def Show(caseDir1):
    global caseDir
    caseDir = caseDir1
    initialize()
    app = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    dialog_1 = MyDialog(None, wx.ID_ANY, "")
    app.SetTopWindow(dialog_1)
    dialog_1.Show()
    app.MainLoop()



class MyDialog(wx.Dialog):
    def __init__(self, *args, **kwds):
        # begin wxGlade: MyDialog.__init__
        kwds["style"] = wx.DEFAULT_DIALOG_STYLE | wx.RESIZE_BORDER | wx.THICK_FRAME
        wx.Dialog.__init__(self, *args, **kwds)
        self.label_1 = wx.StaticText(self, wx.ID_ANY, _(u"layerの設定"))
        self.label_2 = wx.StaticText(self, wx.ID_ANY, _(u"patch名"))
        self.list_box_1 = wx.ListBox(self, wx.ID_ANY, choices=[], style=wx.LB_MULTIPLE)
        self.button_1 = wx.Button(self, wx.ID_ANY, _(u"選択>>"))
        self.button_2 = wx.Button(self, wx.ID_ANY, _(u"<<戻す"))
        self.label_3 = wx.StaticText(self, wx.ID_ANY, _(u"設定するpatch名"))
        self.list_box_2 = wx.ListBox(self, wx.ID_ANY, choices=[], style=wx.LB_MULTIPLE)
        self.sizer_3_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"layerを設定するpatchの選択"))
        self.label_4 = wx.StaticText(self, wx.ID_ANY, _("nSurfaceLayers:"))
        self.label_8 = wx.StaticText(self, wx.ID_ANY, _("relativeSizes:"))
        self.label_5 = wx.StaticText(self, wx.ID_ANY, _("finalLayerThickness:"))
        self.label_6 = wx.StaticText(self, wx.ID_ANY, _("minThickness:"))
        self.label_7 = wx.StaticText(self, wx.ID_ANY, _("expansionRatio:"))
        self.text_ctrl_1 = wx.TextCtrl(self, wx.ID_ANY, "")
        self.combo_box_1 = wx.ComboBox(self, wx.ID_ANY, choices=[], style=wx.CB_DROPDOWN)
        self.text_ctrl_2 = wx.TextCtrl(self, wx.ID_ANY, "")
        self.text_ctrl_3 = wx.TextCtrl(self, wx.ID_ANY, "")
        self.text_ctrl_4 = wx.TextCtrl(self, wx.ID_ANY, "")
        self.label_10 = wx.StaticText(self, wx.ID_ANY, _(u"layerの数"))
        self.label_11 = wx.StaticText(self, wx.ID_ANY, _(u"相対厚さ設定"))
        self.label_12 = wx.StaticText(self, wx.ID_ANY, "")
        self.label_13 = wx.StaticText(self, wx.ID_ANY, "")
        self.label_14 = wx.StaticText(self, wx.ID_ANY, _(u"layerの拡大率"))
        self.label_9 = wx.StaticText(self, wx.ID_ANY, _(u"patch毎に設定を変える場合は、\n「snappyHexMeshDict」を直接編集する。"))
        self.sizer_9_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"layerの設定"))
        self.button_3 = wx.Button(self, wx.ID_ANY, _(u"キャンセル"))
        self.button_4 = wx.Button(self, wx.ID_ANY, _("OK"))

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.onSelectPatch, self.button_1)
        self.Bind(wx.EVT_BUTTON, self.onReturnPatch, self.button_2)
        self.Bind(wx.EVT_BUTTON, self.onCancel, self.button_3)
        self.Bind(wx.EVT_BUTTON, self.onOK, self.button_4)
        # end wxGlade

        self.setPatchNamesToListBox()
        self.setLayerPatchNamesToListBox()
        self.setLayerSettingToTextBoxes()


    def __set_properties(self):
        # begin wxGlade: MyDialog.__set_properties
        self.SetTitle(_(u"layerの設定"))
        self.button_1.SetMinSize((80, 40))
        self.button_2.SetMinSize((80, 30))
        self.label_4.SetMinSize((105, 28))
        self.label_8.SetMinSize((98, 28))
        self.label_5.SetMinSize((140, 28))
        self.label_6.SetMinSize((91, 28))
        self.label_7.SetMinSize((105, 28))
        self.text_ctrl_1.SetMinSize((80, 28))
        self.label_10.SetMinSize((150, 28))
        self.label_11.SetMinSize((150, 30))
        self.label_12.SetMinSize((7, 28))
        self.label_13.SetMinSize((14, 28))
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: MyDialog.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_13 = wx.BoxSizer(wx.VERTICAL)
        sizer_14 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_9_staticbox.Lower()
        sizer_9 = wx.StaticBoxSizer(self.sizer_9_staticbox, wx.VERTICAL)
        sizer_16 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_10 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_15 = wx.BoxSizer(wx.VERTICAL)
        sizer_12 = wx.BoxSizer(wx.VERTICAL)
        sizer_11 = wx.BoxSizer(wx.VERTICAL)
        self.sizer_3_staticbox.Lower()
        sizer_3 = wx.StaticBoxSizer(self.sizer_3_staticbox, wx.VERTICAL)
        sizer_4 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_8 = wx.BoxSizer(wx.VERTICAL)
        sizer_6 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_7 = wx.BoxSizer(wx.VERTICAL)
        sizer_5 = wx.BoxSizer(wx.VERTICAL)
        sizer_2 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_2.Add(self.label_1, 0, wx.TOP | wx.BOTTOM | wx.ALIGN_CENTER_HORIZONTAL, 10)
        sizer_1.Add(sizer_2, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)
        sizer_5.Add(self.label_2, 0, wx.LEFT, 10)
        sizer_5.Add(self.list_box_1, 1, wx.ALL | wx.EXPAND, 5)
        sizer_4.Add(sizer_5, 1, wx.EXPAND, 0)
        sizer_7.Add(self.button_1, 0, wx.LEFT | wx.RIGHT, 5)
        sizer_7.Add(self.button_2, 0, wx.LEFT | wx.RIGHT, 5)
        sizer_6.Add(sizer_7, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_4.Add(sizer_6, 0, wx.EXPAND, 0)
        sizer_8.Add(self.label_3, 0, wx.LEFT, 10)
        sizer_8.Add(self.list_box_2, 1, wx.ALL | wx.EXPAND, 5)
        sizer_4.Add(sizer_8, 1, wx.EXPAND, 0)
        sizer_3.Add(sizer_4, 1, wx.EXPAND, 0)
        sizer_1.Add(sizer_3, 1, wx.LEFT | wx.RIGHT | wx.TOP | wx.EXPAND, 10)
        sizer_11.Add(self.label_4, 0, wx.TOP | wx.ALIGN_RIGHT, 5)
        sizer_11.Add(self.label_8, 0, wx.ALIGN_RIGHT, 0)
        sizer_11.Add(self.label_5, 0, wx.ALIGN_RIGHT, 0)
        sizer_11.Add(self.label_6, 0, wx.ALIGN_RIGHT, 0)
        sizer_11.Add(self.label_7, 0, wx.ALIGN_RIGHT, 0)
        sizer_10.Add(sizer_11, 0, wx.LEFT | wx.EXPAND, 10)
        sizer_12.Add(self.text_ctrl_1, 0, wx.EXPAND, 0)
        sizer_12.Add(self.combo_box_1, 0, wx.EXPAND, 0)
        sizer_12.Add(self.text_ctrl_2, 0, wx.EXPAND, 0)
        sizer_12.Add(self.text_ctrl_3, 0, wx.EXPAND, 0)
        sizer_12.Add(self.text_ctrl_4, 0, wx.EXPAND, 0)
        sizer_10.Add(sizer_12, 1, wx.RIGHT | wx.EXPAND, 0)
        sizer_15.Add(self.label_10, 0, wx.TOP, 5)
        sizer_15.Add(self.label_11, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_15.Add(self.label_12, 0, 0, 0)
        sizer_15.Add(self.label_13, 0, 0, 0)
        sizer_15.Add(self.label_14, 0, wx.RIGHT, 5)
        sizer_10.Add(sizer_15, 0, wx.EXPAND, 0)
        sizer_9.Add(sizer_10, 1, wx.EXPAND, 0)
        sizer_16.Add(self.label_9, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)
        sizer_9.Add(sizer_16, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)
        sizer_1.Add(sizer_9, 1, wx.LEFT | wx.RIGHT | wx.TOP | wx.EXPAND, 10)
        sizer_13.Add((20, 10), 0, 0, 0)
        sizer_14.Add(self.button_3, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM, 20)
        sizer_14.Add(self.button_4, 0, wx.RIGHT, 20)
        sizer_13.Add(sizer_14, 0, wx.ALIGN_RIGHT, 0)
        sizer_1.Add(sizer_13, 0, wx.EXPAND, 0)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade

    # 選択
    def onSelectPatch(self, event):  # wxGlade: MyDialog.<event_handler>
        self.selecLayertPatch(event)

    # 戻す
    def onReturnPatch(self, event):  # wxGlade: MyDialog.<event_handler>
        self.returnLayerPatch(event)

    # cancel
    def onCancel(self, event):  # wxGlade: MyDialog.<event_handler>
        self.Destroy()
    # OK
    def onOK(self, event):  # wxGlade: MyDialog.<event_handler>
        error = self.setSnappyHexMeshDict()
        if error == "":
            title = _(u"layerの設定")
            mess = _(u"snappyHexMeshDictを作成しました。")
            print mess
            self.okDialog(title, mess)
            self.Destroy()

# end of class MyDialog

    #  returnLayerPatch
    #    選択したlayerPatchを戻す
    def returnLayerPatch(self, event):
        global patchNames, layerPatchNames
        #選択したpatchを取得
        names = []
        nSel = self.list_box_2.GetSelections()
        for n in nSel:
            names.append(self.list_box_2.GetString(n))
        #選択したpatchをlistBox2から削除
        newPatchNames = []
        for patch in layerPatchNames:
            flag = 0
            for delName in names:
                if patch == delName:
                    flag = 1
                    break
            if flag == 0:
                newPatchNames.append(patch)
        layerPatchNames = newPatchNames
        self.setLayerPatchNamesToListBox()
        #patchに加える
        patchNames += names
        patchNames.sort()
        self.setPatchNamesToListBox()
        for name in names:
            self.list_box_1.SetStringSelection(name, True)

    #  selecLayertPatch
    #    選択したlayerPatchに設定する
    def selecLayertPatch(self, event):
        global patchNames, layerPatchNames
        #選択patchを取得
        names = []
        nSel = self.list_box_1.GetSelections()
        for n in nSel:
            names.append(self.list_box_1.GetString(n))
        #選択patchをlistBox1から削除
        newPatchNames = []
        for patch in patchNames:
            flag = 0
            for delName in names:
                if patch == delName:
                    flag = 1
                    break
            if flag == 0:
                newPatchNames.append(patch)
        patchNames = newPatchNames
        self.setPatchNamesToListBox()
        #layerPatchに加える
        layerPatchNames += names
        layerPatchNames.sort()
        self.setLayerPatchNamesToListBox()
        for name in names:
            self.list_box_2.SetStringSelection(name, True)



    #  setPatchNamesToListBox
    #    patch名をlistBoxにセット
    def setPatchNamesToListBox(self):
        global patchNames
        self.list_box_1.Clear()
        self.list_box_1.AppendItems(patchNames)

    #  setLayerPatchNamesToListBox
    #    layerPatch名をセット
    def setLayerPatchNamesToListBox(self):
        global layerPatchNames
        self.list_box_2.Clear()
        self.list_box_2.AppendItems(layerPatchNames)

    #  setLayerSettingToTextBoxes
    #    layerの設定内容をtextBoxに表示
    def setLayerSettingToTextBoxes(self):
        global layerSetting
        self.text_ctrl_1.SetValue(layerSetting[0])
        self.combo_box_1.Clear()
        self.combo_box_1.AppendItems(["true", "false"])
        if layerSetting[1] == "true":
            self.combo_box_1.SetStringSelection("true")
        elif layerSetting[1] == "false":
            self.combo_box_1.SetStringSelection("false")
        else:
            self.combo_box_1.SetStringSelection("true")
        self.combo_box_1.SetValue(layerSetting[1])
        self.text_ctrl_2.SetValue(layerSetting[2])
        self.text_ctrl_3.SetValue(layerSetting[3])
        self.text_ctrl_4.SetValue(layerSetting[4])

    #  setSnappyHexMeshDict
    #    snappyHexMeshDictの書き換え
    def setSnappyHexMeshDict(self):
        global layerPatchNames, layerSetting
        [layerPatchNames, layerSetting] = self.getLayerPatchAndSetting()
        error = self.checkLayerPatchSetting(layerPatchNames, layerSetting)
        if error != "":
            return error
        contents = getSnappyHexMeshDictCont(caseDir)
        contents = setSwitchSnappyHexMeshDict(contents)
        contents = deleteGeometry(contents)
        contents = deleteFeatureRefinement(contents)
        contents = deleteLayersPatch(contents)
        contents = setLayersPatch(contents)
        error = self.writeSnappyHexMeshDict(caseDir, contents)
        return ""

    #  getLayerPatchAndSetting
    #    layerの設定を取得
    def getLayerPatchAndSetting(self):
        #layerPatchを取得
        patchNames = []
        n = self.list_box_2.GetCount()
        i = 0
        while i<n:
            name = self.list_box_2.GetString(i)
            patchNames.append(name)
            i += 1
        #layerSettingを取得
        setting = ["", "", "", "", ""]
        setting[0] = self.text_ctrl_1.GetValue()
        setting[1] = self.combo_box_1.GetStringSelection()
        setting[2] = self.text_ctrl_2.GetValue()
        setting[3] = self.text_ctrl_3.GetValue()
        setting[4] = self.text_ctrl_4.GetValue()
        return [patchNames, setting]

    #  checkLayerPatchSetting
    #    errorチェック
    def checkLayerPatchSetting(self, patchNames, setting):
        error = ""
        title = _(u"エラー")
        #layerPatchのチェック
        if len(patchNames) == 0:
            mess = _(u"layerを設定するpatchが選択されていません。")
            mess += _(u"patchを選択してください。")
            error = "NG"
            self.errDialog(title, mess)
            return error

        #settingをチェック
        count = 0
        for item in setting:
            if item == "":
                count += 1
        if count != 0:
            mess = _(u"layerの設定内に設定されていない項目があります。")
            error = "NG"
            self.errDialog(title, mess)
            return error

        i = 0
        for item in setting:
            if i == 1:
                if item != "true" and item != "false":
                    mess = _(u"relativeSizesに true false 以外が入力されています。")
                    error = "NG"
            else:
                try:
                    a = float(item)
                except:
                    mess = _(u"layer設定内容に数字以外の文字が入力されています。")
                    error = "NG"
            i += 1
        if error != "":
            self.errDialog(title, mess)
        return error

    #  writeSnappyHexMeshDict
    #    snappyHexMeshDictの書き込み
    def writeSnappyHexMeshDict(self, caseDir, contents):
        title = _(u"エラー")
        if len(glob.glob(caseDir + "/system")) == 0:
            mess = _(u"systemフォルダが無い為、書き込めません。")
            self.errDialog(title, mess)
            error = "NG"
            return error

        fileName = caseDir + "/system/snappyHexMeshDict"
        try:
            f=open(fileName, "w"); f.write(contents); f.close()
            error = ""
        except:
            mess = _(u"snappyHexMeshDictが保存できません。")
            self.errDialog(title, mess)
            error = "NG"
        return error            
        


    def okDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_INFORMATION) 
        dlg.ShowModal()
        dlg.Destroy()

    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_HAND) 
        dlg.ShowModal()
        dlg.Destroy()

    def yesNoDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.YES | wx.NO | wx.ICON_INFORMATION) 
        res = dlg.ShowModal()
        if res == wx.ID_YES:
            ans = "YES"
        else:
            ans = "NO"
        dlg.Destroy()
        return ans



#
#  initialize
#    初期化
def initialize():
    global meshDir, patchNames, layerPatchNames, layerSetting
    #全patch名を取得
    maxTime = getFoamContents.getCurrTimeFolder(caseDir)
    region = "."
    meshName = "boundary"
    relativeMeshDir = getFoamContents.getCurrMeshDir(caseDir, maxTime, region, meshName)
    meshDir = caseDir + "/" + relativeMeshDir
    ans = getFoamContents.getPatchNameFromBoundary(meshDir)
    names = []
    for [patchName, patchType, nFace, startFace] in ans:
        names.append(patchName)
    #layerPatchとlayerSettingを取得
    [layerPatchNames, layerSetting] = getLayerPatchNamesFromDict(caseDir)
    layerPatchNames.sort()
    #全patch名からlayerPatchを削除
    patchNames = []
    for patch in names:
        same = 0
        for layerPatch in layerPatchNames:
            if patch == layerPatch:
                same = 1
                break
        if same == 0:
            patchNames.append(patch)
    patchNames.sort()
    #全patchに含まれないlayerPatchを削除
    layerPatches = []
    for layer in layerPatchNames:
        for name in names:
            if name == layer:
                layerPatches.append(name)
                break
    layerPatchNames = layerPatches
    layerPatchNames.sort()


#  getLayerPatchNamesFromDict
#    snappyHexMeshDictからlayerPatch名を取得
def getLayerPatchNamesFromDict(caseDir):
    if len(glob.glob(caseDir+"/system")) == 0:
        return []

    fileName = caseDir + "/system/decomposeParDict"
    print len(glob.glob(fileName))
    if len(glob.glob(fileName)) == 0:
        copyDecomposeParDict(caseDir)    
    fileName = caseDir + "/system/snappyHexMeshDict"
    if len(glob.glob(fileName)) == 0:
        copySnappyHexMeshDict(caseDir)
    cont = getSnappyHexMeshDictCont(caseDir)
    cont = getFoamContents.deleteCommentChars(cont)
    [layerCont, p] = getFoamContents.getKeywordContentsMem("addLayersControls", cont, 0)
    [layerPatches, p] = getFoamContents.getKeywordContentsMem("layers", layerCont, 0)
    #layerPatch名を取得
    patches = []
    [lineCont, p, kind] = getFoamContents.get1lineMem(layerPatches, 0)
    while lineCont != "":
        patches.append(lineCont.split()[0])
        [lineCont, p, kind] = getFoamContents.get1lineMem(layerPatches, p)
    #layerSettingを取得
    setting = ["", "", "", "", ""]
    [lineCont, p, kind] = getFoamContents.get1lineMem(layerCont, 0)
    while lineCont != "":
        if kind == "line":
            items = lineCont.split()
            item = items[0]
            value = ""
            if len(items) > 1:
                value = items[1].split(";")[0]
            if item == "nSurfaceLayers":
                setting[0] = value
            elif item == "relativeSizes":
                setting[1] = value
            elif item == "finalLayerThickness":
                setting[2] = value
            elif item == "minThickness":
                setting[3] = value
            elif item == "expansionRatio":
                setting[4] = value
        [lineCont, p, kind] = getFoamContents.get1lineMem(layerCont, p)
    return [patches, setting]


#  getSnappyHexMeshDictCont
#    snappyHexMeshDictを返す
#    fileが無かった場合は、「""」を返す
def getSnappyHexMeshDictCont(caseDir):
    if len(glob.glob(caseDir+"/system")) == 0:
        return ""
    fileName = caseDir + "/system/snappyHexMeshDict"
    if len(glob.glob(fileName)) == 0:
        return ""
    f=open(fileName); cont=f.read(); f.close()
    return cont

#  copySnappyHexMeshDict
#    snappyHexMeshDictをコピーする
def copySnappyHexMeshDict(caseDir):
    helyxosFolders = glob.glob(os.environ["TreeFoamPath"] + "/data/HelyxOS/newCase*")
    helyxosFolders.sort()
    sourceDir = helyxosFolders[-1]
    sourceSnappy = sourceDir + "/system/snappyHexMeshDict"
    distFile = caseDir + "/system/snappyHexMeshDict"
    comm = "cp " + sourceSnappy + " " + distFile
    os.system(comm)
    print comm

#  copyDecomposeParDict
#    decomposeParDictをコピーする
def copyDecomposeParDict(caseDir):
    helyxosFolders = glob.glob(os.environ["TreeFoamPath"] + "/data/HelyxOS/newCase*")
    helyxosFolders.sort()
    sourceDir = helyxosFolders[-1]
    sourceFile = sourceDir + "/system/decomposeParDict"
    distFile = caseDir + "/system/decomposeParDict"
    comm = "cp " + sourceFile + " " + distFile
    os.system(comm)
    print comm

#  setSwitchSnappyHexMeshDict
#    snappyのswitchを設定
def setSwitchSnappyHexMeshDict(cont):
    ps = getFoamContents.skipFoamFileMem(cont, 0)
    newLine = "castellatedMesh false;"
    [cont, p, stat] = getFoamContents.replace1lineMem(cont, ps, newLine)
    newLine = "snap false;"
    [cont, p, stat] = getFoamContents.replace1lineMem(cont, ps, newLine)
    newLine = "addLayers true;"
    [cont, p, stat] = getFoamContents.replace1lineMem(cont, ps, newLine)
    return cont

#  deleteGeometry
#    snappyHexMeshDictのgeometry部を削除
def deleteGeometry(cont):
    count = 0
    p = getFoamContents.skipFoamFileMem(cont, 0)
    newLine = "geometry\n    {\n    }"
    [cont, p, stat] = getFoamContents.replace1lineMem(cont, p, newLine)
    return cont

#  deleteFeatureRefinement
#    snappyHexMeshDictのfeature、refinement部を削除
def deleteFeatureRefinement(cont):
    count = 0
    p = getFoamContents.skipFoamFileMem(cont, 0)
    [lineCont, p, kind] = getFoamContents.get1lineMem(cont, p)
    while lineCont != "" and count == 0:
        if kind == "keyword":
            [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
            if keyword == "castellatedMeshControls":
                ps = p - len(lineCont)
                header = cont[:ps]
                footer = cont[p:]
                castCont = clearFeatureRefinement(lineCont)
                count += 1
        [lineCont, p, kind] = getFoamContents.get1lineMem(cont, p)
    cont = header + castCont + footer
    return cont


#  clearFeatureRefinement
def clearFeatureRefinement(cont):
    ps = skipUntilChara(cont, 0, "{")
    newLine = "features\n        (\n        );"
    [cont, p, keyword] = getFoamContents.replace1lineMem(cont, ps, newLine)
    newLine = "refinementSurfaces\n        {\n        }"
    [cont, p, keyword] = getFoamContents.replace1lineMem(cont, ps, newLine)
    newLine = "refinementRegions\n        {\n        }"
    [cont, p, keyword] = getFoamContents.replace1lineMem(cont, ps, newLine)
    return cont


#  deleteLayersPatch
#    snappyHexMeshDictのlayer部分を削除
def deleteLayersPatch(cont):
    count = 0
    p = getFoamContents.skipFoamFileMem(cont, 0)
    [lineCont, p, kind] = getFoamContents.get1lineMem(cont, p)
    while lineCont != "" and count == 0:
        if kind == "keyword":
            [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
            if keyword == "addLayersControls":
                ps = p - len(lineCont)
                header = cont[:ps]
                footer = cont[p:]
                layersCont = clearLayersPatch(lineCont)
                count += 1
        [lineCont, p, kind] = getFoamContents.get1lineMem(cont, p)
    cont = header + layersCont + footer
    return cont

#  clearLayersPatch
def clearLayersPatch(contents):
    [cont, p] = getFoamContents.getMiddlePairMem(contents, 0)
    #n = contents.find("{")
    #header = contents[:n+1]
    ps = skipUntilChara(contents, 0, "{")
    header = contents[:ps]
    footer = contents[p-1:]
    newLine = "layers\n        {\n        }"
    [cont, p, keyword] = getFoamContents.replace1lineMem(cont, 0, newLine)
    lines = cont[p:].split("\n")
    newLines = []
    spLines = []
    for line in lines:
        words = line.split()
        if len(words) > 0:
            if (words[0] == "nSurfaceLayers" or words[0] == "relativeSizes"
                or words[0] == "finalLayerThickness" or words[0] == "minThickness"
                or words[0] == "expansionRatio"):
                pass
            else:
                newLines.append(line)
        else:
            newLines.append(line)
    newCont = cont[:p] + "\n".join(newLines)
    cont = header + newCont + footer
    return cont

#  setLayersPatch
#    layerの設定をセット
def setLayersPatch(cont):
    count = 0
    p = getFoamContents.skipFoamFileMem(cont, 0)
    [lineCont, p, kind] = getFoamContents.get1lineMem(cont, p)
    while lineCont != "" and count == 0:
        if kind == "keyword":
            [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)

            if keyword == "addLayersControls":
                ps = p - len(lineCont)
                header = cont[:ps]
                footer = cont[p:]
                layersCont = createLayersPatch(lineCont)
                count += 1
        [lineCont, p, kind] = getFoamContents.get1lineMem(cont, p)
    cont = header + layersCont + footer
    return cont

#  createLayersPatch
def createLayersPatch(contents):
    [cont, p] = getFoamContents.getMiddlePairMem(contents, 0)
    header = contents[:p-len(cont)-1]
    footer = contents[p-1:]
    newLine = newLayerPatches()
    [cont, p, keyword] = getFoamContents.replace1lineMem(cont, 0, newLine)
    addLines = addLayerSetting()
    newCont = header + cont[:p] + addLines + cont[p:] + footer
    return newCont

#  newLayerPatches
#    layerを作成する
def newLayerPatches():
    header = "layers\n        {\n"
    footer = "        }"
    word = ""
    for patch in layerPatchNames:
        word += "            " + patch + "\n"
        word += "            {\n"
        word += "                nSurfaceLayers " + layerSetting[0] + ";\n"
        word += "                //finalLayerThickness " + layerSetting[2] + ";\n"
        word += "                //minThickness " + layerSetting[3] + ";\n"
        word += "                //expansionRatio " + layerSetting[4] + ";\n"
        word += "            }\n"
    newLine = header + word + footer
    return newLine

#  addLayerSetting
#    設定内容
def addLayerSetting():
    lines  = "\n"
    lines += "        nSurfaceLayers " + layerSetting[0] + ";\n"
    lines += "        relativeSizes " + layerSetting[1] + ";\n"
    lines += "        finalLayerThickness " + layerSetting[2] + ";\n"
    lines += "        minThickness " + layerSetting[3] + ";\n"
    lines += "        expansionRatio " + layerSetting[4] + ";"
    return lines

#
#  skipUntilChara
#    指定した文字までskip
def skipUntilChara(cont, p, Schar):
    [chara, p] = getFoamContents.get1charaMem(cont, p)
    while chara != Schar and chara != "":
        [chara, p] = getFoamContents.get1charaMem(cont, p)
    return p





if __name__ == "__main__":
    import gettext
    treeFoamPath = os.environ["TreeFoamPath"]
    gettext.install("treefoam", treeFoamPath + "/data/locale")

    app = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    dialog_1 = MyDialog(None, wx.ID_ANY, "")
    app.SetTopWindow(dialog_1)
    dialog_1.Show()
    app.MainLoop()
